
#include <iostream>

#include "mythread.h"

using namespace std;

// g++ tinc.cpp -lpthread -o tinc

//creation du mutex
mutex_t mut;

void trace(int x)
{
    printf("x = %d\n", x);
    
    return;
};

callback_t maFonc(void* x)
{
    //recastage de x
  int* intX = (int*)x;
    
    
    //ATTENTION voici la zone critique seule un thread à le droit 
    // de modifier la veleur de X
    
    mutex_lock(mut);        
        *intX = *intX +2;
        trace(*intX);
    mutex_unlock(mut);
    
    //Fin de zone critique
    //un thread en file d'attente peut rentrer
    
    return 0;
};

int main()
{
    //Création de x
    int x=3;
    
    //initialisation du mutex
    mutex_init(mut);
    
    cout<<"mutex init"<<endl;
    
    //Creation des threads
    thread_t thrd[10];

    int i;
    for(i = 0; i < 10; i++)
        thread_create(thrd[i], maFonc, &x);

    cout<<"thread cree"<<endl;

    //attente de la fermeture des threads
    for(i = 0; i < 10; i++)
       thread_wait_close(thrd[i]);
    
    //destruction des threads et du mutex
   for(i = 0; i < 10; i++)
        thread_delete(thrd[i]);
        
    mutex_delete(mut);
    
    printf("\n\nX Final = %d\n", x);
    
    cin>>x; 
    return 0;
};
