#include <iostream>
#include "mythread.h"

//creation du mutex
mutex_t mut;
mutex_t io;

using namespace std;

void trace(int x)
{
    //Vue que trace est appeler par un thread 
    //et qu'elle utilise les entrers sorties
    //il faut utiliser un autre mutex
    
    //ATTENTION voici la zone critique seule un thread à le droit 
    //d'utiliser l'ES
    
    mutex_lock(io);
        printf("x = %d\n", x);
    mutex_unlock(io);
    
    //Fin de zone critique
    //un thread en file d'attente peut rentrer
    
    return;
};

callback_t maFonc(void* x)
{
    //recastage de x
  int* intX = (int*)x;
  
    
    
    //ATTENTION voici la zone critique seule un thread à le droit 
    // de modifier la veleur de X
    
   mutex_lock(mut);

    *intX = *intX +2;

   mutex_unlock(mut);
    
    //Fin de zone critique
    //un thread en file d'attente peut rentrer
    
   trace(*intX);
    
    return 0;
};

int main()
{
    //Création de x
    int x=2;
    
    //initialisation du mutex
    mutex_init(mut);
    mutex_init(io);
    
    //Creation des threads
    thread_t thrd_tab[10] ;
  
    int i=0;

    cout<<"init"<<endl;

    for(i = 0; i < 10; i++)
        thread_create(thrd_tab[i], maFonc, &x);
   

  
    //attente de la fermeture des threads
    for(i = 0; i < 10; i++)
        thread_wait_close(thrd_tab[i]);

    cout<<"wait end"<<endl;

    //destruction des threads et du mutex

   for(i = 0; i < 10; i++)
      thread_delete(thrd_tab[i]);

 

    cout<<"dell"<<endl;  

   mutex_delete( mut );
   mutex_delete( io );
    
    printf("\n\nX Final = %d\n", x);
    cin>>x;
    
    return 0;
};
